Java异常处理机制

2020-05-13 16:10:04来源:博客园 阅读 ()

容器云强势上线!快速搭建集群,上万Linux镜像随意使用

Java异常处理机制

异常机制

img

什么是异常?

异常是程序中的一些错误,但并不是所有的错误都是异常,并且错误有时候是可以避免的。 程序运行过程中,出现不期而至的各种状况,将它们统称为异常。

比如说,你的代码少了一个分号,那么运行出来结果是提示是错误 java.lang.Error;

如果你用System.out.println(11/0),那么你是因为你用0做了除数,会抛出 java.lang.ArithmeticException 的异常。

异常发生的原因有很多,通常包含以下几大类:

  • 用户输入了非法数据。

  • 要打开的文件不存在/文件格式不对。

  • 读取空数据库

  • 网络通信时连接中断

  • JVM内存溢出。

这些异常有的是因为用户错误引起,有的是程序错误引起的,还有其它一些是因为物理错误引起的。-

简单分类

检查性异常

最具代表的检查性异常是用户错误或问题引起的异常,这是程序员无法预见的。

例如要打开一个不存在文件时,一个异常就发生了,这些异常在编译时不能被简单地忽略。

运行时异常

运行时异常是可能被程序员避免的异常。

与检查性异常相反,运行时异常可以在编译时被忽略。

错误ERROR

错误不是异常,而是脱离程序员控制的问题。错误在代码中通常被忽略。

例如,当栈溢出时,一个错误就发生了,它们在编译也检查不到的。

异常的体系结构

Java把异常当做对象来处理,并定义了一个基类java.lang.Throwable作为所有异常的超类

Java 语言定义了许多异常类在 java.lang 标准包中,主要分为Error和Exception两大类。

image-20200513194452081

Error

Error类对象由JVM生成并抛出,大多数错误与代码编写者所执行的操作无关。

错误 描述
VirtualMachineError 抛出以表明Java虚拟机已损坏或已耗尽资源以使其继续运行。
OutOfMemoryError Java虚拟机由于内存不足而无法分配对象时抛出,并且垃圾收集器不再有可用的内存。
StackOverflowError 当堆栈溢出发生时抛出一个应用程序递归太深。
InternalError 在Java虚拟机中引发了一些意外的内部错误。
UnknownError 当Java虚拟机中出现未知但严重的异常时抛出。
AWTError 当出现严重的抽象窗口工具包错误时抛出。

还有发生在虚拟机试图执行应用时,如类定义错误NoClassDefFoundError、链接错误LinkageError

这些错误时不可查的,因为他们在应用程序的控制和处理能力之外,而且绝大多数是程序运行时不允许出现的状况。

Exception

在Exception分支中有一个重要的子类RuntimeException(运行时异常)

异常 描述
ArrayIndexOutOfBoundsException 用非法索引访问数组时抛出的异常。如果索引为负或大于等于数组大小,则该索引为非法索引。
NullPointerException 空指针异常
ClassCastException 当试图将对象强制转换为不是实例的子类时,抛出该异常。
ArithmeticException 当出现异常的运算条件时,抛出此异常。例如,一个整数"除以0"时,抛出此类的一个实例。
IllegalMonitorStateException 抛出的异常表明某一线程已经试图等待对象的监视器,或者试图通知其他正在等待对象的监视器而本身没有指定监视器的线程。
ClassNotFoundException 找不到类
IllegalThreadStateException 线程没有处于请求操作所要求的适当状态时抛出的异常。
IndexOutOfBoundsException 指示某排序索引(例如对数组、字符串或向量的排序)超出范围时抛出。
NegativeArraySizeException 如果应用程序试图创建大小为负的数组,则抛出该异常。
NullPointerException 当应用程序试图在需要对象的地方使用 null 时,抛出该异常
NumberFormatException 当应用程序试图将字符串转换成一种数值类型,但该字符串不能转换为适当格式时,抛出该异常。
SecurityException 由安全管理器抛出的异常,指示存在安全侵犯。
StringIndexOutOfBoundsException 此异常由 String 方法抛出,指示索引或者为负,或者超出字符串的大小。
UnsupportedOperationException 当不支持请求的操作时,抛出该异常。

非检查异常,可以在程序中捕获处理,也可以不处理。

这些异常一般是由程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生。

Error和Exception的区别

Error通常是灾难性的致命错误,是程序无法控制和处理的,当出现这些异常时,JVM一般会选择终止线程;

Exception通常情况下是可以被程序处理的,并且在程序中应该尽可能的去处理这些异常。

异常方法

下面的列表是 Throwable 类的主要方法:

序号 方法及说明
1 public String getMessage() 返回关于发生的异常的详细信息。这个消息在Throwable 类的构造函数中初始化了。
2 public Throwable getCause() 返回一个Throwable 对象代表异常原因。
3 public String toString() 使用getMessage()的结果返回类的串级名字。
4 public void printStackTrace() 打印toString()结果和栈层次到System.err,即错误输出流。
5 public StackTraceElement [] getStackTrace() 返回一个包含堆栈层次的数组。下标为0的元素代表栈顶,最后一个元素代表方法调用堆栈的栈底。
6 public Throwable fillInStackTrace() 用当前的调用栈层次填充Throwable 对象栈层次,添加到栈层次任何先前信息中。

异常处理机制

五个关键字try、catch、finally、throw、throws

捕获异常try /catch

使用 try 和 catch 关键字可以捕获异常。try/catch 代码块放在异常可能发生的地方。

try/catch代码块中的代码称为保护代码,使用 try/catch 的语法如下:

try
{
    // try监控区域
}catch(ExceptionName e)
{
    // catch 捕获异常
}catch(ExceptionName e1)
{
    // catch 捕获异常
}finally{
    // 处理善后工作
}

finally区可以不要,在IO流,资源关闭时使用。

catch(想要捕获的异常类型) 最高级别Throwable

假设要捕获多个异常:从小到大!

IDEA快捷键

选中监控区域代码 --> Ctrl + Alt + T

抛出异常throws/throw

如果一个方法没有捕获到一个检查性异常,那么该方法必须使用 throws 关键字来声明。throws 关键字放在方法签名的尾部。

也可以使用 throw 关键字抛出一个异常,无论它是新实例化的还是刚捕获到的。

throws是用在方法名尾部,可以声明抛出多个异常,多个异常之间用逗号隔开。

import java.io.*;
public class className
{
   public void withdraw(double amount) throws RemoteException,
                              InsufficientFundsException
   {
       // Method implementation
   }
   //Remainder of class definition
}

throw是用在方法体内,主动抛出异常

public class ThrowTest {
    public static void main(String[] args) {
        int a = 1;
        int b = 0;

        try {
            System.out.println(divide(a, b));
        } catch (Exception e) {
            System.out.println("分母不能为0");
            //e.printStackTrace();
        }
    }

    public static double divide(int a, int b) {
        if (b == 0) {
            // 主动抛出异常
            throw new ArithmeticException();
        }
        return 1.0*a/b;
    }
}

结果

分母不能为0

自定义异常

使用Java内置异常类可以描述在编程时出现的大部分异常情况。除此之外,用户还可以自定义异常。

用户自定义异常类,只需继承Exception类即可。

自定义异常步骤:

  1. 创建自定义异常类

  2. 在方法中通过throw关键字抛出异常对象

  3. 如果在当前抛出异常的方法中处理异常,可以使用try-catch语句捕获并处理;

    否则在方法声明出通过throws关键字向外抛出异常

  4. 在出现异常方法的调用者中捕获并处理异常

自定义异常类

public class CustomException extends Exception {
    // 传递数字
    private int detail;

    public CustomException(int detail) {
        this.detail = detail;
    }

    // 打印异常信息
    @Override
    public String toString() {
        return "CustomException{" + detail + '}';
    }
}

测试方法test抛出异常 throw,再通过throws向外抛出

public class Test {
    public static void main(String[] args) {
        try {
            test(11);
        } catch (CustomException e) {
            System.out.println("打印自定义异常信息");
            System.out.println(e);
        }

    }

    static void test(int a) throws CustomException {
        System.out.println("传输一个参数" + a);
        if (a > 10) {
            // 抛出自定义异常
            throw new CustomException(a);
        }
        System.out.println("ok");
    }
}

最后在main方法捕获处理异常

总结

  • 处理运行是异常时,采用逻辑去合理规避,同时辅助try-catch处理
  • 在多重catch块后面,可以加一个catch(Exception)来处理可能会被遗漏的异常
  • 对于不确定的代码,也可以加上try-catch,处理潜在的异常
  • 尽量去处理异常,切忌只是简单的调用printStackTrace()去打印输出
  • 具体如何处理异常,要根据不同的业务需求和异常类型去决定
  • 尽量添加finally语句块去释放占用的资源。

原文链接:https://www.cnblogs.com/1101-/p/12885032.html
如有疑问请与原作者联系

标签:AVIE虚拟机sys添加POST

版权申明:本站文章部分自网络,如有侵权,请联系:west999com@outlook.com
特别注意:本站所有转载文章言论不代表本站观点,本站所提供的摄影照片,插画,设计作品,如需使用,请与原作者联系,版权归原作者所有

上一篇:你真的以为计算机网络不重要吗,这份书单帮你搞定相关面试题!

下一篇:@PostConstruct注解详解